
package de.ivu.elect.presentation.ergebnis.menu;

import javax.inject.Inject;

import de.ivu.elect.business.ergebnis.boundary.ErgebnisSessionSelect;
import de.ivu.elect.business.ergebnis.entity.Ergebnis;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.dokumente.menu.DokumentErzeugenMenuItemEntry;
import de.ivu.elect.presentation.ergebnis.dokumente.gesamtergebnis.GesamtErgebnisDokumentErzeugenView;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public class GesamtErgebnisDokumentErzeugenMenuItemEntry extends AbstractMenuItemEntry implements DokumentErzeugenMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient ErgebnisSessionSelect ergebnisSessionSelect;

  @Inject
  private transient ErgebnisMenuDisabled ergebnisMenuDisabled;

  public GesamtErgebnisDokumentErzeugenMenuItemEntry() {
    super();
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.DOKUMENT_ERZEUGEN_GESAMT_ERGEBNIS);
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return KEINE_GEBIET_SECURITY;
  }

  @Override
  public boolean isDisabledInternal() {
    return ergebnisMenuDisabled.isDisabled(this) || isDisabledInternal(ergebnisSessionSelect.getEntity());
  }

  protected boolean isDisabledInternal(Ergebnis ergebnis) {
    return ergebnis == null || ergebnis.isStatusUnbekannt();
  }

  @Override
  public String getTargetViewId() {
    return GesamtErgebnisDokumentErzeugenView.VIEW_ID;
  }

  @Override
  public String getLabelKey() {
    return "gesamt.ergebnis.dokument.menu.item.label";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconDocument();
  }
}
